/*
 * TopView.h
 * 
 * Copyright (C) 2008 Matthias Schiffer <matthias@gamezock.de>
 * 
 * This program is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef ZOOMEDIT_VIEW_TOPVIEW_H_
#define ZOOMEDIT_VIEW_TOPVIEW_H_

#include "View.h"

namespace ZoomEdit {

namespace Data {
class Level;
class Room;
class Vertex;
}

namespace View {

class TopView : public View {
  private:
    class Edge {
      public:
        const Data::Vertex *v1, *v2;
        
        Edge(const Data::Vertex *v10, const Data::Vertex *v20)
        : v1(v10), v2(v20) {};
        bool operator<(const Edge &e) const;
    };
    
    Data::Level *level;
    
    void drawGrid(Gui::RenderArea *renderArea);
    void renderRoom(Data::Room *room);
    
  public:
    TopView(Data::Level *level0 = 0) : level(level0) {}
    
    Data::Level* getLevel() {return level;}
    void setLevel(Data::Level *level0) {level = level0;}
    
    virtual void render(Gui::RenderArea *renderArea);
};

}
}

#endif /*ZOOMEDIT_VIEW_TOPVIEW_H_*/
